<?php

namespace Ankou;

use Exception;
use FML\ManiaLink;
use FML\Controls\Frame;
use FML\Controls\Label;
use FML\Controls\Quad;
use FML\Controls\Labels\Label_Text;
use FML\Controls\Quads\Quad_Icons64x64_1;
use FML\Script\Features\ActionTrigger;
use FML\Script\Features\MapInfo;
use ManiaControl\Admin\AuthenticationManager;
use ManiaControl\Callbacks\CallbackListener;
use ManiaControl\Callbacks\Callbacks;
use ManiaControl\Callbacks\CallbackManager;
use ManiaControl\Callbacks\Structures\Common\StatusCallbackStructure;
use ManiaControl\Callbacks\Structures\ShootMania\OnShootStructure;
use ManiaControl\Callbacks\Structures\TrackMania\OnScoresStructure;
use ManiaControl\Commands\CommandListener;
use ManiaControl\Communication\CommunicationAnswer;
use ManiaControl\Communication\CommunicationListener;
use ManiaControl\Players\Player;
use ManiaControl\Players\PlayerManager;
use ManiaControl\Plugins\Plugin;
use ManiaControl\ManiaControl;
use \ManiaControl\Logger;
use ManiaControl\Settings\Setting;
use ManiaControl\Settings\SettingManager;
use ManiaControl\Configurator\GameModeSettings;
use ManiaControl\Utils\Formatter;
use Maniaplanet\DedicatedServer\InvalidArgumentException;
use ManiaControl\Callbacks\TimerListener; // for pause
use ManiaControl\Files\AsyncHttpRequest;
use ManiaControl\Maps\Map;
/**
 * SpecChat
 *
 * @author  Ankou
 * @version 1.0
 */
class RandomMapPlugin implements CallbackListener, CommandListener, TimerListener, CommunicationListener, Plugin
{
	const ID      = 196;
	const VERSION = 1.0;
	const NAME    = 'RandomMap';
	const AUTHOR  = 'Ankou';







	/** @var ManiaControl $maniaControl */
	private $maniaControl = null;



	/**
	 * @see \ManiaControl\Plugins\Plugin::load()
	 */
	public function load(ManiaControl $maniaControl)
	{
		$this->maniaControl = $maniaControl;


		//Commands
		$this->maniaControl->getCommandManager()->registerCommandListener('randommap', $this, 'onRandomMapCommand', false, 'Set a random map in the queue.');
	
	
		//===========================================================================================================================
		//settings===================================================================================================================
		//===========================================================================================================================

		
	
	}




	//=================================================================================================================================================================
	//==[OnCommands]===============================================================================================================================================================
	//=================================================================================================================================================================

	public function onRandomMapCommand(array $chatCallback, Player $player)
	{
		$maps = $this->maniaControl->getMapManager()->getMaps();
		$i = rand(0, count($maps)-1);


        $this->maniaControl->getMapManager()->getMapQueue()->clearMapQueue();
    
        $this->maniaControl->getMapManager()->getMapQueue()->serverAddMapToMapQueue($maps[$i]->uid);
      
        $this->maniaControl->getClient()->nextMap();
		

	}



	/**
	 * @see \ManiaControl\Plugins\Plugin::unload()
	 */
	public function unload()
	{
		$this->maniaControl = null;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getId()
	 */
	public static function getId()
	{
		return self::ID;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getName()
	 */
	public static function getName()
	{
		return self::NAME;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getVersion()
	 */
	public static function getVersion()
	{
		return self::VERSION;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getAuthor()
	 */
	public static function getAuthor()
	{
		return self::AUTHOR;
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::getDescription()
	 */
	public static function getDescription()
	{
		return 'SpecChat';
	}

	/**
	 * @see \ManiaControl\Plugins\Plugin::prepare()
	 */
	public static function prepare(ManiaControl $maniaControl)
	{
		// TODO: Implement prepare() method.
	}
}
